Default = {
	name	="gHUD",
	version	="10012",
	author	="Mahiro/Grognaz - Aegwynn(EU)",
}

Options = {
	["update"]		= 0.01,
	["standby"] 	= 0,
	["lock"]		= 1,
	
	["showParty"]	= 1,
	["showTT"]		= 1,
	["showPet"]		= 1,
	["defMode"]		= 1,
	--["defModeHP"]		= 0,
	--["defModeMP"]		= 0,
	["defFormat"]	= 0,
	--["showDeficit"]		= 1,
	
	["name"]		= 1,
	["nameFormat"] 	= 4,
	
	["bgHeight"] 	= 250,
	["bgWidth"] 	= 10,
	["barWidth"] 	= 10,
	
	["playerPosX"] 	= 310,
	["playerPosY"] 	= -120,
	["targetPosX"] 	= 40,
	["targetPosY"] 	= 0,
	["partyPosX"] 	= 20,
	["partyPosY"] 	= 0,
	["petPosX"] 	= 20,
	["petPosY"] 	= 0,
	["ttPosX"] 		= 30,
	["ttPosY"] 		= 0,

	flash ={
		["Bar"] 		= 0,
		["BG"] 			= 1,
		["In"] 			= 0.3,
		["Out"] 		= 0.3,
		["Duration"]	= 1000,
		["InHold"] 	 	= 0,
		["OutHold"] 	= 0,
	},
	font = {
		["font"] 	= "Interface\\AddOns\\gHUD\\fonts\\comicbd.ttf",
		["size"] 	= 9,
		["flags"] 	= "",
	},
	texture = {
		["BarHeight"] 		= "Interface\\AddOns\\gHUD\\texture\\bar",
		["BarHeightINV"] 	= "Interface\\AddOns\\gHUD\\texture\\barINV",
	},
}

Colors = {
	hp100 = {
		["r"]	=0,
		["g"]	=1,
		["b"]	=0,
		["a"]	=1,
	},
	hp50 = {
		["r"]	=1,
		["g"]	=1,
		["b"]	=0,
		["a"]	=1,
	},
	hp20 = {
		["r"]	=1,
		["g"]	=0,
		["b"]	=0,
		["a"]	=1,
	},
	mp100 = {
		["r"]	=0,
		["g"]	=0,
		["b"]	=1,
		["a"]	=1,
	},
	mp50 = {
		["r"]	=1,
		["g"]	=1,
		["b"]	=1,
		["a"]	=1,
	},
	mp20 = {
		["r"]	=1,
		["g"]	=0,
		["b"]	=0,
		["a"]	=1,
	},
}
---------------------------------------------------------
function gHUDOnLoad()

--Slash Commands	
	SLASH_gHUD_1 = "/groggy hud"
	SLASH_gHUD_2 = "/ghud"
	SlashCmdList["gHUD_"] = gHUD_Command
---------------------------------------------------------
--Handlers
	this:RegisterEvent("ADDON_LOADED")
	this:RegisterEvent("PLAYER_TARGET_CHANGED") 
	this:RegisterEvent("PARTY_MEMBERS_CHANGED")
	this:RegisterEvent("UNIT_PET")
	this.TimeSinceLastUpdate=0
end
--------------------------------------------------------
function TargetChangeOnEvent()
--show/hide target frames
	if (event=="PLAYER_TARGET_CHANGED") then
		if (UnitExists("target")) then
			HP_TARGET_FRAME:Show()
			if (UnitIsPlayer("target")==nil) 
			and (UnitPowerType("target")==1)  then
				MP_TARGET_FRAME:SetAlpha(0) 
			else
				MP_TARGET_FRAME:SetAlpha(Colors.mp100.a) 
			end
		end
	end
end

function PartyChangeOnEvent()
	if (event=="PARTY_MEMBERS_CHANGED") then 
		if UnitInParty("party1") then
			HP_PARTY1_FRAME:Show()
			MP_PARTY1_FRAME:Show()
		else
			HP_PARTY1_FRAME:Hide()
			MP_PARTY1_FRAME:Hide()
		end
		if UnitInParty("party2") then
			HP_PARTY2_FRAME:Show()
			MP_PARTY2_FRAME:Show()
		else
			HP_PARTY2_FRAME:Hide()
			MP_PARTY2_FRAME:Hide()
		end
		if UnitInParty("party3") then
			HP_PARTY3_FRAME:Show()
			MP_PARTY3_FRAME:Show()
		else
			HP_PARTY3_FRAME:Hide()
			MP_PARTY3_FRAME:Hide()
		end
		if UnitInParty("party4") then
			HP_PARTY4_FRAME:Show()
			MP_PARTY4_FRAME:Show()
		else
			HP_PARTY4_FRAME:Hide()
			MP_PARTY4_FRAME:Hide()
		end
	end
end

function PetChangeOnEvent()
--show/hide pet frames
	if (event=="UNIT_PET") then
		if (UnitExists("pet")) then
			HP_PET_FRAME:Show()
			MP_PET_FRAME:Show()
		else 
			HP_PET_FRAME:Hide()
			MP_PET_FRAME:Hide()
		end
	end
end
---------------------------------------------------------
function Load_HP_Player()
	if (event=="ADDON_LOADED") and (arg1=="gHUD") then
	--set position
		HP_PLAYER_FRAME:ClearAllPoints()
		HP_PLAYER_FRAME:SetPoint("CENTER", nil, "CENTER", -Options.playerPosX, Options.playerPosY)
	--texture
		HP_PLAYER_BAR_TEXTURE:SetTexture(Options.texture.BarHeight)
		
		HP_PLAYER_BG_TEXTURE1:SetHeight(Options.bgHeight)
		HP_PLAYER_BG_TEXTURE1:SetWidth(Options.bgWidth)
		HP_PLAYER_BG_TEXTURE2:SetHeight(Options.bgHeight-2)
		HP_PLAYER_BG_TEXTURE2:SetWidth(Options.bgWidth-2)
		
		HP_PLAYER_BAR:SetWidth(Options.barWidth)
		HP_PLAYER_FRAME:SetHeight(Options.bgHeight)
		HP_PLAYER_FRAME:SetWidth(Options.bgWidth)
		
		HP_Player_Button:SetHeight(Options.bgHeight)
		HP_Player_Button:SetWidth(Options.bgWidth)
	--hp player max text
		HP_PLAYER_MAX:SetFont(Options.font.font, Options.font.size, Options.font.flags)
		HP_PLAYER_MAX:SetTextColor(0, 1, 0, 1)
	--hp player current text
		HP_PLAYER_CURRENT:SetFont(Options.font.font, Options.font.size, Options.font.flags)
	--hp player percent text
		HP_PLAYER_PERCENT:SetFont(Options.font.font, Options.font.size, Options.font.flags)
	--hp player deficit text
		HP_PLAYER_DEFICIT:SetFont(Options.font.font, Options.font.size, Options.font.flags)
	--hp player name text
		HP_PLAYER_NAME:SetFont(Options.font.font, Options.font.size, Options.font.flags)
		--HP_PLAYER_NAME:SetTextColor(0, 1, 0, 1)
	end
end
---------------------------------------------------------
function Load_MP_Player()
	if (event=="ADDON_LOADED") and (arg1=="gHUD") then
	--set position
		MP_PLAYER_FRAME:ClearAllPoints()
		MP_PLAYER_FRAME:SetPoint("CENTER", nil, "CENTER", Options.playerPosX, Options.playerPosY)
	--texture
		MP_PLAYER_BAR_TEXTURE:SetTexture(Options.texture.BarHeight)
		
		MP_PLAYER_BG_TEXTURE1:SetHeight(Options.bgHeight)
		MP_PLAYER_BG_TEXTURE1:SetWidth(Options.bgWidth)
		MP_PLAYER_BG_TEXTURE2:SetHeight(Options.bgHeight-2)
		MP_PLAYER_BG_TEXTURE2:SetWidth(Options.bgWidth-2)
		
		MP_PLAYER_BAR:SetWidth(Options.barWidth)
		MP_PLAYER_FRAME:SetHeight(Options.bgHeight)
		MP_PLAYER_FRAME:SetWidth(Options.bgWidth)
		
		MP_Player_Button:SetHeight(Options.bgHeight)
		MP_Player_Button:SetWidth(Options.bgWidth)
	--hp player max text
		MP_PLAYER_MAX:SetFont(Options.font.font, Options.font.size, Options.font.flags)
		if (UnitPowerType("player")==0) then
			MP_PLAYER_MAX:SetTextColor(0, 0, 1, 1)
		elseif (UnitPowerType("player")==1) then
			MP_PLAYER_MAX:SetTextColor(1, 0, 0, 1)
		elseif (UnitPowerType("player")==2) then
			MP_PLAYER_MAX:SetTextColor(1, 1, 0, 1)
		elseif (UnitPowerType("player")==3) then
			MP_PLAYER_MAX:SetTextColor(1, 1, 0, 1)
		end
	--hp player current text
		MP_PLAYER_CURRENT:SetFont(Options.font.font, Options.font.size, Options.font.flags)
	--hp player percent text
		MP_PLAYER_PERCENT:SetFont(Options.font.font, Options.font.size, Options.font.flags)
	--hp player deficit text
		MP_PLAYER_DEFICIT:SetFont(Options.font.font, Options.font.size, Options.font.flags)
	end
end
------------------------------------------------------------------------------------------------------------------
function Load_HP_Target()
	if (event=="ADDON_LOADED") and (arg1=="gHUD") then	
	--set position
		HP_TARGET_FRAME:ClearAllPoints()
		HP_TARGET_FRAME:SetPoint("BOTTOM", HP_PLAYER_FRAME, "BOTTOM", Options.targetPosX, Options.targetPosY)
	--texture
		HP_TARGET_BAR_TEXTURE:SetTexture(Options.texture.BarHeight)
		
		HP_TARGET_BG_TEXTURE1:SetHeight(Options.bgHeight)
		HP_TARGET_BG_TEXTURE1:SetWidth(Options.bgWidth)
		HP_TARGET_BG_TEXTURE2:SetHeight(Options.bgHeight-2)
		HP_TARGET_BG_TEXTURE2:SetWidth(Options.bgWidth-2)
		
		HP_TARGET_BAR:SetWidth(Options.barWidth)
		HP_TARGET_FRAME:SetHeight(Options.bgHeight)
		HP_TARGET_FRAME:SetWidth(Options.bgWidth)
		
		HP_Target_Button:SetHeight(Options.bgHeight)
		HP_Target_Button:SetWidth(Options.bgWidth)
	--hp target max text
		HP_TARGET_MAX:SetFont(Options.font.font, Options.font.size, Options.font.flags)
		HP_TARGET_MAX:SetTextColor(0, 1, 0, 1)
	--hp target current text
		HP_TARGET_CURRENT:SetFont(Options.font.font, Options.font.size, Options.font.flags)
	--hp target percent text
		HP_TARGET_PERCENT:SetFont(Options.font.font, Options.font.size, Options.font.flags)
	--hp target deficit text
		HP_TARGET_DEFICIT:SetFont(Options.font.font, Options.font.size, Options.font.flags)
	--hp target name text
		HP_TARGET_NAME:SetFont(Options.font.font, Options.font.size, Options.font.flags)
		--HP_TARGET_NAME:SetTextColor(0, 1, 0, 1)
	end
end
---------------------------------------------------------
function Load_MP_Target()
	if (event=="ADDON_LOADED") and (arg1=="gHUD") then	
	--set position
		MP_TARGET_FRAME:ClearAllPoints()
		MP_TARGET_FRAME:SetPoint("BOTTOM", MP_PLAYER_FRAME, "BOTTOM", -Options.targetPosX, Options.targetPosY)
	--texture
		MP_TARGET_BAR_TEXTURE:SetTexture(Options.texture.BarHeight)
		
		MP_TARGET_BG_TEXTURE1:SetHeight(Options.bgHeight)
		MP_TARGET_BG_TEXTURE1:SetWidth(Options.bgWidth)
		MP_TARGET_BG_TEXTURE2:SetHeight(Options.bgHeight-2)
		MP_TARGET_BG_TEXTURE2:SetWidth(Options.bgWidth-2)
		
		MP_TARGET_BAR:SetWidth(Options.barWidth)
		MP_TARGET_FRAME:SetHeight(Options.bgHeight)
		MP_TARGET_FRAME:SetWidth(Options.bgWidth)
		
		MP_Target_Button:SetHeight(Options.bgHeight)
		MP_Target_Button:SetWidth(Options.bgWidth)
	--hp target max text
		MP_TARGET_MAX:SetFont(Options.font.font, Options.font.size, Options.font.flags)
	--hp target current text
		MP_TARGET_CURRENT:SetFont(Options.font.font, Options.font.size, Options.font.flags)
	--hp target percent text
		MP_TARGET_PERCENT:SetFont(Options.font.font, Options.font.size, Options.font.flags)
	--hp target deficit text
		MP_TARGET_DEFICIT:SetFont(Options.font.font, Options.font.size, Options.font.flags)
	end
end
------------------------------------------------------------------------------------------------------------------
function Load_HP_Party1()
	if (event=="ADDON_LOADED") and (arg1=="gHUD") then	
		if (Options.showParty==1) then
		--set position
			HP_PARTY1_FRAME:ClearAllPoints()
			HP_PARTY1_FRAME:SetPoint("BOTTOM", HP_PLAYER_FRAME, "BOTTOM", -Options.partyPosX, Options.partyPosY)
		--texture
			HP_PARTY1_BAR_TEXTURE:SetTexture(Options.texture.BarHeight)
		
			HP_PARTY1_BG_TEXTURE1:SetHeight((Options.bgHeight/4)-3)
			HP_PARTY1_BG_TEXTURE1:SetWidth(Options.bgWidth)
			HP_PARTY1_BG_TEXTURE2:SetHeight((Options.bgHeight/4)-5)
			HP_PARTY1_BG_TEXTURE2:SetWidth(Options.bgWidth-2)
		
			HP_PARTY1_BAR:SetWidth(Options.barWidth)
			HP_PARTY1_FRAME:SetHeight((Options.bgHeight/4)-3)
			HP_PARTY1_FRAME:SetWidth(Options.bgWidth)
			
			HP_Party1_Button:SetHeight((Options.bgHeight/4)-3)
			HP_Party1_Button:SetWidth(Options.bgWidth)
		--hp party1 max text
			HP_PARTY1_MAX:SetFont(Options.font.font, Options.font.size, Options.font.flags)
			HP_PARTY1_MAX:SetTextColor(0, 1, 0, 1)
		--hp party1 current text
			HP_PARTY1_CURRENT:SetFont(Options.font.font, Options.font.size, Options.font.flags)
		--hp party1 percent text
			HP_PARTY1_PERCENT:SetFont(Options.font.font, Options.font.size, Options.font.flags)
		--hp party1 deficit text
			HP_PARTY1_DEFICIT:SetFont(Options.font.font, Options.font.size, Options.font.flags)
		--hp party1 name text
			HP_PARTY1_NAME:SetFont(Options.font.font, Options.font.size, Options.font.flags)
			--HP_PARTY1_NAME:SetTextColor(0, 1, 0, 1)
		else
			HP_PARTY1_FRAME:Hide()
		end
	end
end
---------------------------------------------------------
function Load_MP_Party1()
	if (event=="ADDON_LOADED") and (arg1=="gHUD") then
		if (Options.showParty==1) then
		--set position
			MP_PARTY1_FRAME:ClearAllPoints()
			MP_PARTY1_FRAME:SetPoint("BOTTOM", MP_PLAYER_FRAME, "BOTTOM", Options.partyPosX, Options.partyPosY)
		--texture
			MP_PARTY1_BAR_TEXTURE:SetTexture(Options.texture.BarHeight)
		
			MP_PARTY1_BG_TEXTURE1:SetHeight((Options.bgHeight/4)-3)
			MP_PARTY1_BG_TEXTURE1:SetWidth(Options.bgWidth)
			MP_PARTY1_BG_TEXTURE2:SetHeight((Options.bgHeight/4)-5)
			MP_PARTY1_BG_TEXTURE2:SetWidth(Options.bgWidth-2)
		
			MP_PARTY1_BAR:SetWidth(Options.barWidth)
			MP_PARTY1_FRAME:SetHeight((Options.bgHeight/4)-3)
			MP_PARTY1_FRAME:SetWidth(Options.bgWidth)
		
			MP_Party1_Button:SetHeight((Options.bgHeight/4)-3)
			MP_Party1_Button:SetWidth(Options.bgWidth)
		--hp party1 max text
			MP_PARTY1_MAX:SetFont(Options.font.font, Options.font.size, Options.font.flags)
			if (UnitPowerType("party1")==0) then
				MP_PARTY1_MAX:SetTextColor(0, 0, 1, 1)
			elseif (UnitPowerType("party1")==1) then
				MP_PARTY1_MAX:SetTextColor(1, 0, 0, 1)
			elseif (UnitPowerType("party1")==2) then
				MP_PARTY1_MAX:SetTextColor(1, 1, 0, 1)
			elseif (UnitPowerType("party1")==3) then
				MP_PARTY1_MAX:SetTextColor(1, 1, 0, 1)
			end
		--hp party1 current text
			MP_PARTY1_CURRENT:SetFont(Options.font.font, Options.font.size, Options.font.flags)
		--hp party1 percent text
			MP_PARTY1_PERCENT:SetFont(Options.font.font, Options.font.size, Options.font.flags)
		--hp party1 deficit text
			MP_PARTY1_DEFICIT:SetFont(Options.font.font, Options.font.size, Options.font.flags)
		else
			MP_PARTY1_FRAME:Hide()
		end
	end
end
------------------------------------------------------------------------------------------------------------------
function Load_HP_Party2()
	if (event=="ADDON_LOADED") and (arg1=="gHUD") then	
		if (Options.showParty==1) then
		--texture
			HP_PARTY2_BAR_TEXTURE:SetTexture(Options.texture.BarHeight)
		
			HP_PARTY2_BG_TEXTURE1:SetHeight((Options.bgHeight/4)-3)
			HP_PARTY2_BG_TEXTURE1:SetWidth(Options.bgWidth)
			HP_PARTY2_BG_TEXTURE2:SetHeight((Options.bgHeight/4)-5)
			HP_PARTY2_BG_TEXTURE2:SetWidth(Options.bgWidth-2)
		
			HP_PARTY2_BAR:SetWidth(Options.barWidth)
			HP_PARTY2_FRAME:SetHeight((Options.bgHeight/4)-3)
			HP_PARTY2_FRAME:SetWidth(Options.bgWidth)
			
			HP_Party2_Button:SetHeight((Options.bgHeight/4)-3)
			HP_Party2_Button:SetWidth(Options.bgWidth)
		--hp party2 max text
			HP_PARTY2_MAX:SetFont(Options.font.font, Options.font.size, Options.font.flags)
			HP_PARTY2_MAX:SetTextColor(0, 1, 0, 1)
		--hp party2 current text
			HP_PARTY2_CURRENT:SetFont(Options.font.font, Options.font.size, Options.font.flags)
		--hp party2 percent text
			HP_PARTY2_PERCENT:SetFont(Options.font.font, Options.font.size, Options.font.flags)
		--hp party2 deficit text
			HP_PARTY2_DEFICIT:SetFont(Options.font.font, Options.font.size, Options.font.flags)
		--hp party2 name text
			HP_PARTY2_NAME:SetFont(Options.font.font, Options.font.size, Options.font.flags)
			--HP_PARTY2_NAME:SetTextColor(0, 1, 0, 1)
		else
			HP_PARTY2_FRAME:Hide()
		end
	end
end
---------------------------------------------------------
function Load_MP_Party2()
	if (event=="ADDON_LOADED") and (arg1=="gHUD") then
		if (Options.showParty==1) then	
		--texture
			MP_PARTY2_BAR_TEXTURE:SetTexture(Options.texture.BarHeight)
		
			MP_PARTY2_BG_TEXTURE1:SetHeight((Options.bgHeight/4)-3)
			MP_PARTY2_BG_TEXTURE1:SetWidth(Options.bgWidth)
			MP_PARTY2_BG_TEXTURE2:SetHeight((Options.bgHeight/4)-5)
			MP_PARTY2_BG_TEXTURE2:SetWidth(Options.bgWidth-2)
		
			MP_PARTY2_BAR:SetWidth(Options.barWidth)
			MP_PARTY2_FRAME:SetHeight((Options.bgHeight/4)-3)
			MP_PARTY2_FRAME:SetWidth(Options.bgWidth)
		
			MP_Party2_Button:SetHeight((Options.bgHeight/4)-3)
			MP_Party2_Button:SetWidth(Options.bgWidth)
		--hp party2 max text
			MP_PARTY2_MAX:SetFont(Options.font.font, Options.font.size, Options.font.flags)
			if (UnitPowerType("party2")==0) then
				MP_PARTY2_MAX:SetTextColor(0, 0, 1, 1)
			elseif (UnitPowerType("party2")==1) then
				MP_PARTY2_MAX:SetTextColor(1, 0, 0, 1)
			elseif (UnitPowerType("party2")==2) then
				MP_PARTY2_MAX:SetTextColor(1, 1, 0, 1)
			elseif (UnitPowerType("party2")==3) then
				MP_PARTY2_MAX:SetTextColor(1, 1, 0, 1)
			end
		--hp party2 current text
			MP_PARTY2_CURRENT:SetFont(Options.font.font, Options.font.size, Options.font.flags)
		--hp party2 percent text
			MP_PARTY2_PERCENT:SetFont(Options.font.font, Options.font.size, Options.font.flags)
		--hp party2 deficit text
			MP_PARTY2_DEFICIT:SetFont(Options.font.font, Options.font.size, Options.font.flags)
		else	
			MP_PARTY2_FRAME:Hide()
		end
	end
end
------------------------------------------------------------------------------------------------------------------
function Load_HP_Party3()
	if (event=="ADDON_LOADED") and (arg1=="gHUD") then	
		if (Options.showParty==1) then
		--texture
			HP_PARTY3_BAR_TEXTURE:SetTexture(Options.texture.BarHeight)
		
			HP_PARTY3_BG_TEXTURE1:SetHeight((Options.bgHeight/4)-3)
			HP_PARTY3_BG_TEXTURE1:SetWidth(Options.bgWidth)
			HP_PARTY3_BG_TEXTURE2:SetHeight((Options.bgHeight/4)-5)
			HP_PARTY3_BG_TEXTURE2:SetWidth(Options.bgWidth-2)
		
			HP_PARTY3_BAR:SetWidth(Options.barWidth)
			HP_PARTY3_FRAME:SetHeight((Options.bgHeight/4)-3)
			HP_PARTY3_FRAME:SetWidth(Options.bgWidth)
			
			HP_Party3_Button:SetHeight((Options.bgHeight/4)-3)
			HP_Party3_Button:SetWidth(Options.bgWidth)
		--hp party3 max text
			HP_PARTY3_MAX:SetFont(Options.font.font, Options.font.size, Options.font.flags)
			HP_PARTY3_MAX:SetTextColor(0, 1, 0, 1)
		--hp party3 current text
			HP_PARTY3_CURRENT:SetFont(Options.font.font, Options.font.size, Options.font.flags)
		--hp party3 percent text
			HP_PARTY3_PERCENT:SetFont(Options.font.font, Options.font.size, Options.font.flags)
		--hp party3 deficit text
			HP_PARTY3_DEFICIT:SetFont(Options.font.font, Options.font.size, Options.font.flags)
		--hp party3 name text
			HP_PARTY3_NAME:SetFont(Options.font.font, Options.font.size, Options.font.flags)
			--HP_PARTY3_NAME:SetTextColor(0, 1, 0, 1)
		else
			HP_PARTY3_FRAME:Hide()
		end
	end
end
---------------------------------------------------------
function Load_MP_Party3()
	if (event=="ADDON_LOADED") and (arg1=="gHUD") then
		if (Options.showParty==1) then
		--texture
			MP_PARTY3_BAR_TEXTURE:SetTexture(Options.texture.BarHeight)
		
			MP_PARTY3_BG_TEXTURE1:SetHeight((Options.bgHeight/4)-3)
			MP_PARTY3_BG_TEXTURE1:SetWidth(Options.bgWidth)
			MP_PARTY3_BG_TEXTURE2:SetHeight((Options.bgHeight/4)-5)
			MP_PARTY3_BG_TEXTURE2:SetWidth(Options.bgWidth-2)
		
			MP_PARTY3_BAR:SetWidth(Options.barWidth)
			MP_PARTY3_FRAME:SetHeight((Options.bgHeight/4)-3)
			MP_PARTY3_FRAME:SetWidth(Options.bgWidth)
		
			MP_Party3_Button:SetHeight((Options.bgHeight/4)-3)
			MP_Party3_Button:SetWidth(Options.bgWidth)
		--hp party3 max text
			MP_PARTY3_MAX:SetFont(Options.font.font, Options.font.size, Options.font.flags)
			if (UnitPowerType("party3")==0) then
				MP_PARTY3_MAX:SetTextColor(0, 0, 1, 1)
			elseif (UnitPowerType("party3")==1) then
				MP_PARTY3_MAX:SetTextColor(1, 0, 0, 1)
			elseif (UnitPowerType("party3")==2) then
				MP_PARTY3_MAX:SetTextColor(1, 1, 0, 1)
			elseif (UnitPowerType("party3")==3) then
				MP_PARTY3_MAX:SetTextColor(1, 1, 0, 1)
			end
		--hp party3 current text
			MP_PARTY3_CURRENT:SetFont(Options.font.font, Options.font.size, Options.font.flags)
		--hp party3 percent text
			MP_PARTY3_PERCENT:SetFont(Options.font.font, Options.font.size, Options.font.flags)
		--hp party3 deficit text
			MP_PARTY3_DEFICIT:SetFont(Options.font.font, Options.font.size, Options.font.flags)
		else 
			MP_PARTY3_FRAME:Hide()
		end
	end
end
------------------------------------------------------------------------------------------------------------------
function Load_HP_Party4()
	if (event=="ADDON_LOADED") and (arg1=="gHUD") then	
		if (Options.showParty==1) then
		--texture
			HP_PARTY4_BAR_TEXTURE:SetTexture(Options.texture.BarHeight)
		
			HP_PARTY4_BG_TEXTURE1:SetHeight((Options.bgHeight/4)-3)
			HP_PARTY4_BG_TEXTURE1:SetWidth(Options.bgWidth)
			HP_PARTY4_BG_TEXTURE2:SetHeight((Options.bgHeight/4)-5)
			HP_PARTY4_BG_TEXTURE2:SetWidth(Options.bgWidth-2)
		
			HP_PARTY4_BAR:SetWidth(Options.barWidth)
			HP_PARTY4_FRAME:SetHeight((Options.bgHeight/4)-3)
			HP_PARTY4_FRAME:SetWidth(Options.bgWidth)
			
			HP_Party4_Button:SetHeight((Options.bgHeight/4)-3)
			HP_Party4_Button:SetWidth(Options.bgWidth)
		--hp party4 max text
			HP_PARTY4_MAX:SetFont(Options.font.font, Options.font.size, Options.font.flags)
			HP_PARTY4_MAX:SetTextColor(0, 1, 0, 1)
		--hp party4 current text
			HP_PARTY4_CURRENT:SetFont(Options.font.font, Options.font.size, Options.font.flags)
		--hp party4 percent text
			HP_PARTY4_PERCENT:SetFont(Options.font.font, Options.font.size, Options.font.flags)
		--hp party4 deficit text
			HP_PARTY4_DEFICIT:SetFont(Options.font.font, Options.font.size, Options.font.flags)
		--hp party4 name text
			HP_PARTY4_NAME:SetFont(Options.font.font, Options.font.size, Options.font.flags)
			--HP_PARTY4_NAME:SetTextColor(0, 1, 0, 1)
		else
			HP_PARTY4_FRAME:Hide()
		end
	end
end
---------------------------------------------------------
function Load_MP_Party4()
	if (event=="ADDON_LOADED") and (arg1=="gHUD") then
		if (Options.showParty==1) then	
		--texture
			MP_PARTY4_BAR_TEXTURE:SetTexture(Options.texture.BarHeight)
		
			MP_PARTY4_BG_TEXTURE1:SetHeight((Options.bgHeight/4)-3)
			MP_PARTY4_BG_TEXTURE1:SetWidth(Options.bgWidth)
			MP_PARTY4_BG_TEXTURE2:SetHeight((Options.bgHeight/4)-5)
			MP_PARTY4_BG_TEXTURE2:SetWidth(Options.bgWidth-2)
		
			MP_PARTY4_BAR:SetWidth(Options.barWidth)
			MP_PARTY4_FRAME:SetHeight((Options.bgHeight/4)-3)
			MP_PARTY4_FRAME:SetWidth(Options.bgWidth)
		
			MP_Party4_Button:SetHeight((Options.bgHeight/4)-3)
			MP_Party4_Button:SetWidth(Options.bgWidth)
		--hp party4 max text
			MP_PARTY4_MAX:SetFont(Options.font.font, Options.font.size, Options.font.flags)
			if (UnitPowerType("party4")==0) then
				MP_PARTY4_MAX:SetTextColor(0, 0, 1, 1)
			elseif (UnitPowerType("party4")==1) then
				MP_PARTY4_MAX:SetTextColor(1, 0, 0, 1)
			elseif (UnitPowerType("party4")==2) then
				MP_PARTY4_MAX:SetTextColor(1, 1, 0, 1)
			elseif (UnitPowerType("party4")==3) then
				MP_PARTY4_MAX:SetTextColor(1, 1, 0, 1)
			end
		--hp party4 current text
			MP_PARTY4_CURRENT:SetFont(Options.font.font, Options.font.size, Options.font.flags)
		--hp party4 percent text
			MP_PARTY4_PERCENT:SetFont(Options.font.font, Options.font.size, Options.font.flags)
		--hp party4 deficit text
			MP_PARTY4_DEFICIT:SetFont(Options.font.font, Options.font.size, Options.font.flags)
		else 
			MP_PARTY4_FRAME:Hide()
		end
	end
end
------------------------------------------------------------------------------------------------------------------
function Load_HP_Pet()
	if (event=="ADDON_LOADED") and (arg1=="gHUD") then
		if (Options.showPet==1) then
		--set position
			HP_PET_FRAME:ClearAllPoints()
			HP_PET_FRAME:SetPoint("BOTTOM", HP_PARTY1_FRAME, "BOTTOM", -Options.petPosX, Options.petPosY)
		--texture
			HP_PET_BAR_TEXTURE:SetTexture(Options.texture.BarHeight)
		
			HP_PET_BG_TEXTURE1:SetHeight(Options.bgHeight/2)
			HP_PET_BG_TEXTURE1:SetWidth(Options.bgWidth)
			HP_PET_BG_TEXTURE2:SetHeight((Options.bgHeight/2)-2)
			HP_PET_BG_TEXTURE2:SetWidth(Options.bgWidth-2)
		
			HP_PET_BAR:SetWidth(Options.barWidth)
			HP_PET_FRAME:SetHeight(Options.bgHeight/2)
			HP_PET_FRAME:SetWidth(Options.bgWidth)
			
			HP_Pet_Button:SetHeight(Options.bgHeight/2)
			HP_Pet_Button:SetWidth(Options.bgWidth)
		--hp pet max text
			HP_PET_MAX:SetFont(Options.font.font, Options.font.size, Options.font.flags)
			HP_PET_MAX:SetTextColor(0, 1, 0, 1)
		--hp pet current text
			HP_PET_CURRENT:SetFont(Options.font.font, Options.font.size, Options.font.flags)
		--hp pet percent text
			HP_PET_PERCENT:SetFont(Options.font.font, Options.font.size, Options.font.flags)
		--hp pet deficit text
			HP_PET_DEFICIT:SetFont(Options.font.font, Options.font.size, Options.font.flags)
		--hp pet name text
			HP_PET_NAME:SetFont(Options.font.font, Options.font.size, Options.font.flags)
			--HP_PET_NAME:SetTextColor(0, 1, 0, 1)
		else
			HP_PET_FRAME:Hide()
		end
	end
end
---------------------------------------------------------
function Load_MP_Pet()
	if (event=="ADDON_LOADED") and (arg1=="gHUD") then
		if (Options.showPet==1) then
		--set position
			MP_PET_FRAME:ClearAllPoints()
			MP_PET_FRAME:SetPoint("BOTTOM", MP_PARTY1_FRAME, "BOTTOM", Options.petPosX, Options.petPosY)
		--texture
			MP_PET_BAR_TEXTURE:SetTexture(Options.texture.BarHeight)
		
			MP_PET_BG_TEXTURE1:SetHeight(Options.bgHeight/2)
			MP_PET_BG_TEXTURE1:SetWidth(Options.bgWidth)
			MP_PET_BG_TEXTURE2:SetHeight((Options.bgHeight/2)-2)
			MP_PET_BG_TEXTURE2:SetWidth(Options.bgWidth-2)
		
			MP_PET_BAR:SetWidth(Options.barWidth)
			MP_PET_FRAME:SetHeight(Options.bgHeight/2)
			MP_PET_FRAME:SetWidth(Options.bgWidth)
		
			MP_Pet_Button:SetHeight(Options.bgHeight/2)
			MP_Pet_Button:SetWidth(Options.bgWidth)
		--hp pet max text
			MP_PET_MAX:SetFont(Options.font.font, Options.font.size, Options.font.flags)
		--hp pet current text
			MP_PET_CURRENT:SetFont(Options.font.font, Options.font.size, Options.font.flags)
		--hp pet percent text
			MP_PET_PERCENT:SetFont(Options.font.font, Options.font.size, Options.font.flags)
		--hp pet deficit text
			MP_PET_DEFICIT:SetFont(Options.font.font, Options.font.size, Options.font.flags)
		else 
			MP_PET_FRAME:Hide()
		end
	end
end
------------------------------------------------------------------------------------------------------------------
function Load_HP_TargetTarget()
	if (event=="ADDON_LOADED") and (arg1=="gHUD") then
		if (Options.showTT==1) then
		--set position
			HP_TARGETTARGET_FRAME:ClearAllPoints()
			HP_TARGETTARGET_FRAME:SetPoint("BOTTOM", HP_TARGET_FRAME, "BOTTOM", Options.ttPosX, Options.ttPosY)
		--texture
			HP_TARGETTARGET_BAR_TEXTURE:SetTexture(Options.texture.BarHeight)
		
			HP_TARGETTARGET_BG_TEXTURE1:SetHeight(Options.bgHeight/2)
			HP_TARGETTARGET_BG_TEXTURE1:SetWidth(Options.bgWidth)
			HP_TARGETTARGET_BG_TEXTURE2:SetHeight((Options.bgHeight/2)-2)
			HP_TARGETTARGET_BG_TEXTURE2:SetWidth(Options.bgWidth-2)
		
			HP_TARGETTARGET_BAR:SetWidth(Options.barWidth)
			HP_TARGETTARGET_FRAME:SetHeight(Options.bgHeight/2)
			HP_TARGETTARGET_FRAME:SetWidth(Options.bgWidth)
		
			HP_TargetTarget_Button:SetHeight(Options.bgHeight/2)
			HP_TargetTarget_Button:SetWidth(Options.bgWidth)
		--hp targettarget max text
			HP_TARGETTARGET_MAX:SetFont(Options.font.font, Options.font.size, Options.font.flags)
			HP_TARGETTARGET_MAX:SetTextColor(0, 1, 0, 1)
		--hp targettarget current text
			HP_TARGETTARGET_CURRENT:SetFont(Options.font.font, Options.font.size, Options.font.flags)
		--hp targettarget percent text
			HP_TARGETTARGET_PERCENT:SetFont(Options.font.font, Options.font.size, Options.font.flags)
		--hp targettarget deficit text
			HP_TARGETTARGET_DEFICIT:SetFont(Options.font.font, Options.font.size, Options.font.flags)
		--hp targettarget name text
			HP_TARGETTARGET_NAME:SetFont(Options.font.font, Options.font.size, Options.font.flags)
			--HP_TARGETTARGET_NAME:SetTextColor(0, 1, 0, 1)
		else
			HP_TARGETTARGET_FRAME:Hide()
		end
	end
end
---------------------------------------------------------
function Load_MP_TargetTarget()
	if (event=="ADDON_LOADED") and (arg1=="gHUD") then
		if (Options.showTT==1) then	
		--set position
			MP_TARGETTARGET_FRAME:ClearAllPoints()
			MP_TARGETTARGET_FRAME:SetPoint("BOTTOM", MP_TARGET_FRAME, "BOTTOM", -Options.ttPosX, Options.ttPosY)
		--texture
			MP_TARGETTARGET_BAR_TEXTURE:SetTexture(Options.texture.BarHeight)
		
			MP_TARGETTARGET_BG_TEXTURE1:SetHeight(Options.bgHeight/2)
			MP_TARGETTARGET_BG_TEXTURE1:SetWidth(Options.bgWidth)
			MP_TARGETTARGET_BG_TEXTURE2:SetHeight((Options.bgHeight/2)-2)
			MP_TARGETTARGET_BG_TEXTURE2:SetWidth(Options.bgWidth-2)
		
			MP_TARGETTARGET_BAR:SetWidth(Options.barWidth)
			MP_TARGETTARGET_FRAME:SetHeight(Options.bgHeight/2)
			MP_TARGETTARGET_FRAME:SetWidth(Options.bgWidth)
			
			MP_TargetTarget_Button:SetHeight(Options.bgHeight/2)
			MP_TargetTarget_Button:SetWidth(Options.bgWidth)
		--hp targettarget max text
			MP_TARGETTARGET_MAX:SetFont(Options.font.font, Options.font.size, Options.font.flags)
		--hp targettarget current text
			MP_TARGETTARGET_CURRENT:SetFont(Options.font.font, Options.font.size, Options.font.flags)
		--hp targettarget percent text
			MP_TARGETTARGET_PERCENT:SetFont(Options.font.font, Options.font.size, Options.font.flags)
		--hp targettarget deficit text
			MP_TARGETTARGET_DEFICIT:SetFont(Options.font.font, Options.font.size, Options.font.flags)
		else
			MP_TARGETTARGET_FRAME:Hide()
		end
	end
end
------------------------------------------------------------------------------------------------
function HP_Player(arg1)
	unit = "player"
	tBar = HP_PLAYER_BAR_TEXTURE
	tBG  = HP_PLAYER_BG_TEXTURE1
	fBar = HP_PLAYER_BAR
	fMax = HP_PLAYER_MAX
	fCur = HP_PLAYER_CURRENT
	fPer = HP_PLAYER_PERCENT
	fDef = HP_PLAYER_DEFICIT
	
	fNam = HP_PLAYER_NAME
	
	this.TimeSinceLastUpdate=this.TimeSinceLastUpdate + arg1
	if (this.TimeSinceLastUpdate > Options.update) then	
	--Color
		HealthColor(unit,tBar,tBG,fCur,fPer,fDef)
	--Health
		local cur, max = UnitHealth(unit), UnitHealthMax(unit)
		local deficit = max-cur
	--hp bar
		if (cur==0) then
			fBar:SetHeight(1)
		else
			if (max>=cur) then
				fBar:SetHeight(Options.bgHeight/max*cur)
			else
				fBar:SetHeight(Options.bgHeight)
			end
		end
	--hp name text
		if (Options.name==1) and (not UnitInParty("party1")) then
			fNam:Show()
			ClassColor(unit,fNam)
			fNam:SetText(string.sub(UnitName(unit), 1, Options.nameFormat)) 
		else 
			fNam:Hide()
		end
	--hp max text
		fMax:SetText(max)
	--hp current text
		fCur:SetText(cur)
	--hp percent text
		fPer:SetText(string.format("%.0f", (100/max*cur)) .."%")
	--hp deficit text
		if (cur/max)>0.9
		or (cur/max)<0.1
		or UnitInParty("party1") and (Options.showParty==1) then
			fDef:Hide() 
		else
			fDef:Show()
			if (Options.defFormat==0) then
				fDef:SetText("-" ..deficit)
			elseif (Options.defFormat==1) then		
				fDef:SetText(string.format("-%.1f", (deficit/1000)))
			end
		end
		this.TimeSinceLastUpdate=0
	end
end
---------------------------------------------------------
function HP_Target(arg1)
	unit = "target"
	tBar = HP_TARGET_BAR_TEXTURE
	tBG  = HP_TARGET_BG_TEXTURE1
	fBar = HP_TARGET_BAR
	fMax = HP_TARGET_MAX
	fCur = HP_TARGET_CURRENT
	fPer = HP_TARGET_PERCENT
	fDef = HP_TARGET_DEFICIT
	fNam = HP_TARGET_NAME
	
	this.TimeSinceLastUpdate=this.TimeSinceLastUpdate + arg1
	if (this.TimeSinceLastUpdate > Options.update) then
		if (UnitExists(unit)) then
		--Color
		HealthColor(unit,tBar,tBG,fCur,fPer,fDef)
		--MobHealth
			local cur, max, found
			local deficit
			if MobHealth3 then
				cur, max, found = MobHealth3:GetUnitHealth(unit, UnitHealth(unit), UnitHealthMax(unit))
				deficit = max-cur
			else
				cur, max = UnitHealth(unit), UnitHealthMax(unit)
				deficit = max-cur
			end
		--targettarget	
			if (Options.showTT==1) 
			and (UnitExists("targettarget")) then
				HP_TARGETTARGET_FRAME:SetAlpha(Colors.hp100.a) 
			else 
				HP_TARGETTARGET_FRAME:SetAlpha(0) 
			end
		--hp target bar
			if (cur==0) then
				fBar:SetHeight(1)
			else
				if (max>=cur) then
					fBar:SetHeight(Options.bgHeight/max*cur)
				else
					fBar:SetHeight(Options.bgHeight)
				end
			end
		--hp name text
			if (Options.name==1) then
				ClassColor(unit,fNam)
				fNam:SetText(string.sub(UnitName(unit), 1, Options.nameFormat)) 
			else 
				fNam:SetText()
			end
		--hp max text
			fMax:SetText(max)
		--hp current text
			fCur:SetText(cur)
		--hp percent text
			fPer:SetText(string.format("%.0f", (100/max*cur)) .."%")
		--hp deficit text
			if (cur/max)>0.9
			or (cur/max)<0.1 then
				fDef:Hide() 
			else
				fDef:Show()
				if (Options.defFormat==0) then
					fDef:SetText("-" ..deficit)
				elseif (Options.defFormat==1) then		
					fDef:SetText(string.format("-%.1f", (deficit/1000)))
				end
			end
		end
		this.TimeSinceLastUpdate=0
	end
end
---------------------------------------------------------
function HP_Party1(arg1)
	unit = "party1"
	tBar = HP_PARTY1_BAR_TEXTURE
	tBG  = HP_PARTY1_BG_TEXTURE1
	fBar = HP_PARTY1_BAR
	fBG	 = HP_PARTY1_FRAME
	fMax = HP_PARTY1_MAX
	fCur = HP_PARTY1_CURRENT
	fPer = HP_PARTY1_PERCENT
	fDef = HP_PARTY1_DEFICIT
	fNam = HP_PARTY1_NAME
	
	if (Options.showParty==1) then
		--enable frame
		fBG:SetAlpha(Colors.hp100.a)
		fBG:EnableMouse(true)
		HP_Party1_Button:EnableMouse(true)
		this.TimeSinceLastUpdate=this.TimeSinceLastUpdate + arg1
		if (this.TimeSinceLastUpdate > Options.update) then
			if (UnitExists(unit)) then	
			--Color
			HealthColor(unit,tBar,tBG,fCur,fPer,fDef)
			--Health
			local cur, max = UnitHealth(unit), UnitHealthMax(unit)
			local deficit = max-cur
			--hp bar
				if (cur==0) then
					fBar:SetHeight(1)
				else
					if (max>=cur) then
						fBar:SetHeight(((Options.bgHeight/4)-3)/max*cur)
					else 
						fBar:SetHeight((Options.bgHeight/4)-3)
					end
				end
			--hp name text
				if (Options.name==1) then
					ClassColor(unit,fNam)
					fNam:SetText(string.sub(UnitName(unit), 1, Options.nameFormat)) 
				else 
					fNam:SetText()
				end
			--hp max text
				fMax:Hide()
			--hp current text
				fCur:Hide()
			--hp percent text
				fPer:Hide()
			--hp deficit text
				if (cur/max)>0.9
				or (cur/max)<0.1 then
					fDef:Hide() 
				else
					fDef:Show()
				--defmode deficit
					if (Options.defMode==1) then
						if (Options.defFormat==0) then
							fDef:SetText("-" ..deficit)
						elseif (Options.defFormat==1) then		
							fDef:SetText(string.format("-%.1f", (deficit/1000)))
						end
				--defmode current
					elseif (Options.defMode==0) then
						if (Options.defFormat==0) then
							fDef:SetText(cur)
						elseif (Options.defFormat==1) then		
							fDef:SetText(string.format("%.1f", (cur/1000)))
						end
					end
				end
			end
			this.TimeSinceLastUpdate=0
		end	
	else
		--disable frame
		fBG:SetAlpha(0)
		fBG:EnableMouse(false)
		HP_Party1_Button:EnableMouse(false)
	end
end
---------------------------------------------------------
function HP_Party2(arg1)
	unit = "party2"
	tBar = HP_PARTY2_BAR_TEXTURE
	tBG  = HP_PARTY2_BG_TEXTURE1
	fBar = HP_PARTY2_BAR
	fBG	 = HP_PARTY2_FRAME	
	fMax = HP_PARTY2_MAX
	fCur = HP_PARTY2_CURRENT
	fPer = HP_PARTY2_PERCENT
	fDef = HP_PARTY2_DEFICIT
	fNam = HP_PARTY2_NAME
	if (Options.showParty==1) then
		--enable frame
		fBG:SetAlpha(Colors.hp100.a)
		fBG:EnableMouse(true)
		HP_Party2_Button:EnableMouse(true)
		this.TimeSinceLastUpdate=this.TimeSinceLastUpdate + arg1
		if (this.TimeSinceLastUpdate > Options.update) then
			if (UnitExists(unit)) then	
			--Color
			HealthColor(unit,tBar,tBG,fCur,fPer,fDef)
			--Health
			local cur, max = UnitHealth(unit), UnitHealthMax(unit)
			local deficit = max-cur
			--hp bar
				if (cur==0) then
					fBar:SetHeight(1)
				else
					if (max>=cur) then
						fBar:SetHeight(((Options.bgHeight/4)-3)/max*cur)
					else 
						fBar:SetHeight((Options.bgHeight/4)-3)
					end
				end
			--hp name text
				if (Options.name==1) then
					ClassColor(unit,fNam)
					fNam:SetText(string.sub(UnitName(unit), 1, Options.nameFormat)) 
				else 
					fNam:SetText()
				end
			--hp max text
				fMax:Hide()
			--hp current text
				fCur:Hide()
			--hp percent text
				fPer:Hide()
			--hp deficit text
				if (cur/max)>0.9
				or (cur/max)<0.1 then
					fDef:Hide() 
				else
					fDef:Show()
				--defmode deficit
					if (Options.defMode==1) then
						if (Options.defFormat==0) then
							fDef:SetText("-" ..deficit)
						elseif (Options.defFormat==1) then		
							fDef:SetText(string.format("-%.1f", (deficit/1000)))
						end
				--defmode current
					elseif (Options.defMode==0) then
						if (Options.defFormat==0) then
							fDef:SetText(cur)
						elseif (Options.defFormat==1) then		
							fDef:SetText(string.format("%.1f", (cur/1000)))
						end
					end
				end
			end
			this.TimeSinceLastUpdate=0
		end	
	else
		--disable frame
		fBG:SetAlpha(0)
		fBG:EnableMouse(false)
		HP_Party2_Button:EnableMouse(false) 
	end
end
---------------------------------------------------------
function HP_Party3(arg1)
	unit = "party3"
	tBar = HP_PARTY3_BAR_TEXTURE
	tBG  = HP_PARTY3_BG_TEXTURE1
	fBar = HP_PARTY3_BAR
	fBG	 = HP_PARTY3_FRAME	
	fMax = HP_PARTY3_MAX
	fCur = HP_PARTY3_CURRENT
	fPer = HP_PARTY3_PERCENT
	fDef = HP_PARTY3_DEFICIT
	fNam = HP_PARTY3_NAME
	if (Options.showParty==1) then
		--enable frame
		fBG:SetAlpha(Colors.hp100.a)
		fBG:EnableMouse(true)
		HP_Party3_Button:EnableMouse(true)
		this.TimeSinceLastUpdate=this.TimeSinceLastUpdate + arg1
		if (this.TimeSinceLastUpdate > Options.update) then
			if (UnitExists(unit)) then	
			--Color
			HealthColor(unit,tBar,tBG,fCur,fPer,fDef)
			--Health
			local cur, max = UnitHealth(unit), UnitHealthMax(unit)
			local deficit = max-cur
			--hp bar
				if (cur==0) then
					fBar:SetHeight(1)
				else
					if (max>=cur) then
						fBar:SetHeight(((Options.bgHeight/4)-3)/max*cur)
					else 
						fBar:SetHeight((Options.bgHeight/4)-3)
					end
				end
			--hp name text
				if (Options.name==1) then
					ClassColor(unit,fNam)
					fNam:SetText(string.sub(UnitName(unit), 1, Options.nameFormat)) 
				else 
					fNam:SetText()
				end
			--hp max text
				fMax:Hide()
			--hp current text
				fCur:Hide()
			--hp percent text
				fPer:Hide()
			--hp deficit text
				if (cur/max)>0.9
				or (cur/max)<0.1 then
					fDef:Hide() 
				else
					fDef:Show()
				--defmode deficit
					if (Options.defMode==1) then
						if (Options.defFormat==0) then
							fDef:SetText("-" ..deficit)
						elseif (Options.defFormat==1) then		
							fDef:SetText(string.format("-%.1f", (deficit/1000)))
						end
				--defmode current
					elseif (Options.defMode==0) then
						if (Options.defFormat==0) then
							fDef:SetText(cur)
						elseif (Options.defFormat==1) then		
							fDef:SetText(string.format("%.1f", (cur/1000)))
						end
					end
				end
			end
			this.TimeSinceLastUpdate=0
		end	
	else
		--disable frame
		fBG:SetAlpha(0) 
		fBG:EnableMouse(false)
		HP_Party3_Button:EnableMouse(false)
	end
end
---------------------------------------------------------
function HP_Party4(arg1)
	unit = "party4"
	tBar = HP_PARTY4_BAR_TEXTURE
	tBG  = HP_PARTY4_BG_TEXTURE1
	fBar = HP_PARTY4_BAR
	fBG	 = HP_PARTY4_FRAME	
	fMax = HP_PARTY4_MAX
	fCur = HP_PARTY4_CURRENT
	fPer = HP_PARTY4_PERCENT
	fDef = HP_PARTY4_DEFICIT
	fNam = HP_PARTY4_NAME
	if (Options.showParty==1) then
		--enable frame
		fBG:SetAlpha(Colors.hp100.a)
		fBG:EnableMouse(true)
		HP_Party4_Button:EnableMouse(true)
		this.TimeSinceLastUpdate=this.TimeSinceLastUpdate + arg1
		if (this.TimeSinceLastUpdate > Options.update) then
			if (UnitExists(unit)) then	
			--Color
			HealthColor(unit,tBar,tBG,fCur,fPer,fDef)
			--Health
			local cur, max = UnitHealth(unit), UnitHealthMax(unit)
			local deficit = max-cur
			--hp bar
				if (cur==0) then
					fBar:SetHeight(1)
				else
					if (max>=cur) then
						fBar:SetHeight(((Options.bgHeight/4)-3)/max*cur)
					else 
						fBar:SetHeight((Options.bgHeight/4)-3)
					end
				end
			--hp name text
				if (Options.name==1) then
					ClassColor(unit,fNam)
					fNam:SetText(string.sub(UnitName(unit), 1, Options.nameFormat)) 
				else 
					fNam:SetText()
				end
			--hp max text
				fMax:Hide()
			--hp current text
				fCur:Hide()
			--hp percent text
				fPer:Hide()
			--hp deficit text
				if (cur/max)>0.9
				or (cur/max)<0.1 then
					fDef:Hide() 
				else
					fDef:Show()
				--defmode deficit
					if (Options.defMode==1) then
						if (Options.defFormat==0) then
							fDef:SetText("-" ..deficit)
						elseif (Options.defFormat==1) then		
							fDef:SetText(string.format("-%.1f", (deficit/1000)))
						end
				--defmode current
					elseif (Options.defMode==0) then
						if (Options.defFormat==0) then
							fDef:SetText(cur)
						elseif (Options.defFormat==1) then		
							fDef:SetText(string.format("%.1f", (cur/1000)))
						end
					end
				end
			end
			this.TimeSinceLastUpdate=0
		end	
	else
		--disable frame
		fBG:SetAlpha(0)
		fBG:EnableMouse(false) 
		HP_Party4_Button:EnableMouse(false)
	end
end
---------------------------------------------------------
function HP_Pet(arg1)
	unit = "pet"
	tBar = HP_PET_BAR_TEXTURE
	tBG  = HP_PET_BG_TEXTURE1
	fBar = HP_PET_BAR
	fBG	 = HP_PET_FRAME	
	fMax = HP_PET_MAX
	fCur = HP_PET_CURRENT
	fPer = HP_PET_PERCENT
	fDef = HP_PET_DEFICIT
	fNam = HP_PET_NAME
	if (Options.showPet==1) then
		--enable frame
		fBG:SetAlpha(Colors.hp100.a)
		fBG:EnableMouse(true)
		HP_Pet_Button:EnableMouse(true)
		this.TimeSinceLastUpdate=this.TimeSinceLastUpdate + arg1
		if (this.TimeSinceLastUpdate > Options.update) then
			if (UnitExists(unit)) then	
			--Color
			HealthColor(unit,tBar,tBG,fCur,fPer,fDef)
			--Health
			local cur, max = UnitHealth(unit), UnitHealthMax(unit)
			local deficit = max-cur
			--hp bar
				if (cur==0) then
					fBar:SetHeight(1)
				else
					if (max>=cur) then
						fBar:SetHeight((Options.bgHeight/2)/max*cur)
					else
						fBar:SetHeight(Options.bgHeight/2)
					end
				end
			--hp name text
				if (Options.name==1) then
					ClassColor(unit,fNam)
					fNam:SetText(string.sub(UnitName(unit), 1, Options.nameFormat)) 
				else 
					fNam:SetText()
				end
			--hp max text
				fMax:SetText(UnitHealthMax(unit))
			--hp current text
				fCur:SetText(UnitHealth(unit))
			--hp percent text
				fPer:SetText(string.format("%.0f", (100/max*cur)) .."%")
			--hp deficit text
				if (cur/max)>0.9
				or (cur/max)<0.1 then
					fDef:Hide() 
				else
					fDef:Show()
					if (Options.defFormat==0) then
						fDef:SetText("-" ..deficit)
					elseif (Options.defFormat==1) then		
						fDef:SetText(string.format("-%.1f", (deficit/1000)))
					end
				end
			end
			this.TimeSinceLastUpdate=0
		end
	else
		--disable frame
		fBG:SetAlpha(0) 
		fBG:EnableMouse(false)
		HP_Pet_Button:EnableMouse(false)
	end
end
---------------------------------------------------------
function HP_TargetTarget(arg1)
	unit = "targettarget"
	tBar = HP_TARGETTARGET_BAR_TEXTURE
	tBG  = HP_TARGETTARGET_BG_TEXTURE1
	fBar = HP_TARGETTARGET_BAR
	fBG	 = HP_TARGETTARGET_FRAME	
	fMax = HP_TARGETTARGET_MAX
	fCur = HP_TARGETTARGET_CURRENT
	fPer = HP_TARGETTARGET_PERCENT
	fDef = HP_TARGETTARGET_DEFICIT
	fNam = HP_TARGETTARGET_NAME
	if (Options.showTT==1) then
		--enable frame
		fBG:SetAlpha(Colors.hp100.a)
		fBG:EnableMouse(true)
		HP_TargetTarget_Button:EnableMouse(true)
		this.TimeSinceLastUpdate=this.TimeSinceLastUpdate + arg1
		if (this.TimeSinceLastUpdate > Options.update) then
			if (UnitExists(unit)) then
			--Color
			HealthColor(unit,tBar,tBG,fCur,fPer,fDef)
			--MobHealth
				local cur, max, found
				local deficit
				if MobHealth3 then
					cur, max, found = MobHealth3:GetUnitHealth(unit, UnitHealth(unit), UnitHealthMax(unit))
					deficit = max-cur
				else
					cur, max = UnitHealth(unit), UnitHealthMax(unit)
					deficit = max-cur
				end
			--hp bar
				if (cur==0) then
					fBar:SetHeight(1)
				else
					if (max>=cur) then
						fBar:SetHeight((Options.bgHeight/2)/max*cur)
					else
						fBar:SetHeight(Options.bgHeight/2)
					end
				end
			--hp name text
				if (Options.name==1) then
					ClassColor(unit,fNam)	
					fNam:SetText(string.sub(UnitName(unit), 1, Options.nameFormat)) 
				else 
					fNam:SetText()
				end
			--hp max text
				fMax:SetText(max)
			--hp current text
				fCur:SetText(cur)
			--hp percent text
				fPer:SetText(string.format("%.0f", (100/max*cur)) .."%")
			--hp deficit text
				if (cur/max)>0.9
				or (cur/max)<0.1 then
					fDef:Hide() 
				else
					fDef:Show()
					if (Options.defFormat==0) then
						fDef:SetText("-" ..deficit)
					elseif (Options.defFormat==1) then		
						fDef:SetText(string.format("-%.1f", (deficit/1000)))
					end
				end
			end
			this.TimeSinceLastUpdate=0
		end
	else
		--disable frame
		fBG:SetAlpha(0) 
		fBG:EnableMouse(false)
		HP_TargetTarget_Button:EnableMouse(false)
	end
end
------------------------------------------------------------------------------------------------------------------
function MP_Player(arg1)
	unit = "player"
	tBar = MP_PLAYER_BAR_TEXTURE
	tBG  = MP_PLAYER_BG_TEXTURE1
	fBar = MP_PLAYER_BAR
	fMax = MP_PLAYER_MAX
	fCur = MP_PLAYER_CURRENT
	fPer = MP_PLAYER_PERCENT
	fDef = MP_PLAYER_DEFICIT
	
	this.TimeSinceLastUpdate=this.TimeSinceLastUpdate + arg1
	if (this.TimeSinceLastUpdate > Options.update) then	
	--Color
		ManaColor(unit,tBar,tBG,fCur,fPer,fDef)
	--Health
		local cur, max = UnitMana(unit), UnitManaMax(unit)
		local deficit = max-cur
	--mp bar
		if (cur==0) then
			fBar:SetHeight(1)
		else
			if (max>=cur) then
				fBar:SetHeight(Options.bgHeight/max*cur)
			else
				fBar:SetHeight(Options.bgHeight)
			end
		end
	--mp max text
		fMax:SetText(max)
	--mp current text
		fCur:SetText(cur)
	--mp percent text
		fPer:SetText(string.format("%.0f", (100/max*cur)) .."%")
	--mp deficit text
		if (cur/max)>0.9
		or (cur/max)<0.1 
		or UnitInParty("party1") and (Options.showParty==1) then 
			fDef:Hide()
		else
			if (UnitPowerType(unit)==0) then
				fDef:Show()
				if (Options.defFormat==0) then
					fDef:SetText("-" ..deficit)
				elseif 	(Options.defFormat==1) then
					fDef:SetText(string.format("-%.1f", (deficit/1000)))
				end
			elseif (UnitPowerType(unit)==1)
				or (UnitPowerType(unit)==2)
				or (UnitPowerType(unit)==3) then
					fDef:Show()
					fDef:SetText(cur)
			end
		end
		this.TimeSinceLastUpdate=0
	end
end
---------------------------------------------------------
function MP_Target(arg1)
	unit = "target"
	tBar = MP_TARGET_BAR_TEXTURE
	tBG  = MP_TARGET_BG_TEXTURE1
	fBar = MP_TARGET_BAR
	fMax = MP_TARGET_MAX
	fCur = MP_TARGET_CURRENT
	fPer = MP_TARGET_PERCENT
	fDef = MP_TARGET_DEFICIT
	
	this.TimeSinceLastUpdate=this.TimeSinceLastUpdate + arg1
	if (this.TimeSinceLastUpdate > Options.update) then	
		if (UnitExists(unit)) then	
	--Color
		ManaColor(unit,tBar,tBG,fCur,fPer,fDef)
	--Health
		local cur, max = UnitMana(unit), UnitManaMax(unit)
		local deficit = max-cur
			
			if (Options.showTT==1)
			and (UnitExists("targettarget")) then
				if (UnitIsPlayer("targettarget")==nil) 
				and (UnitPowerType("targettarget")==1) then
					MP_TARGETTARGET_FRAME:SetAlpha(0) 
				else
					MP_TARGETTARGET_FRAME:SetAlpha(Colors.mp100.a) 
				end
			else 
				MP_TARGETTARGET_FRAME:SetAlpha(0)
			end	
		--mp bar
			if (cur==0) then
				fBar:SetHeight(1)
			else
				if (max>=cur) then
					fBar:SetHeight(Options.bgHeight/max*cur)
				else
					fBar:SetHeight(Options.bgHeight)
				end
			end
		--mp max text
			fMax:SetText(UnitManaMax(unit))
			if (UnitPowerType(unit)==0) then
				fMax:SetTextColor(0, 0, 1, 1)
			elseif (UnitPowerType(unit)==1) then
				fMax:SetTextColor(1, 0, 0, 1)
			elseif (UnitPowerType(unit)==2) then
				fMax:SetTextColor(1, 1, 0, 1)
			elseif (UnitPowerType(unit)==3) then
				fMax:SetTextColor(1, 1, 0, 1)
			end
		--mp current text
			fCur:SetText(cur)
		--mp percent text
			fPer:SetText(string.format("%.0f", (100/max*cur)) .."%")
		--mp deficit text
			if (cur/max)>0.9
			or (cur/max)<0.1 then 
				MP_TARGET_DEFICIT:Hide()
			else
				if (UnitPowerType(unit)==0) then
					fDef:Show()
					if (Options.defFormat==0) then
						fDef:SetText("-" ..deficit)
					elseif (Options.defFormat==1) then	
						fDef:SetText(string.format("-%.1f", (deficit/1000)))
					end
				elseif (UnitPowerType(unit)==1)
					or (UnitPowerType(unit)==2)
					or (UnitPowerType(unit)==3) then
						fDef:Show()
						fDef:SetText(cur)
				end
			end
		end
		this.TimeSinceLastUpdate=0
	end
end
---------------------------------------------------------
function MP_Party1(arg1)
	unit = "party1"
	tBar = MP_PARTY1_BAR_TEXTURE
	tBG  = MP_PARTY1_BG_TEXTURE1
	fBar = MP_PARTY1_BAR
	fBG	 = MP_PARTY1_FRAME
	fMax = MP_PARTY1_MAX
	fCur = MP_PARTY1_CURRENT
	fPer = MP_PARTY1_PERCENT
	fDef = MP_PARTY1_DEFICIT
	
	if (Options.showParty==1) then
		--enable frame
		fBG:SetAlpha(Colors.mp100.a)
		fBG:EnableMouse(true)
		MP_Party1_Button:EnableMouse(true)
		this.TimeSinceLastUpdate=this.TimeSinceLastUpdate + arg1
		if (this.TimeSinceLastUpdate > Options.update) then	
			if (UnitExists(unit)) then
		--Color
			ManaColor(unit,tBar,tBG,fCur,fPer,fDef)
		--Health
			local cur, max = UnitMana(unit), UnitManaMax(unit)
			local deficit = max-cur
			--mp bar
				if (cur==0) then
					fBar:SetHeight(1)
				else
					if (max>=cur) then
						fBar:SetHeight(((Options.bgHeight/4)-3)/max*cur)
					else
						fBar:SetHeight((Options.bgHeight/4)-3)
					end
				end
			--mp max text
				fMax:Hide()
			--mp current text
				fCur:Hide()
			--mp percent text
				fPer:Hide()
			--mp deficit text
				if (cur/max)>0.9
				or (cur/max)<0.1 then 
					fDef:Hide()
				else
					if (UnitPowerType(unit)==0) then
						fDef:Show()
					--defmode deficit
						if (Options.defMode==1) then
							if (Options.defFormat==0) then
								fDef:SetText("-" ..deficit)
							elseif (Options.defFormat==1) then		
								fDef:SetText(string.format("-%.1f", (deficit/1000)))
							end
					--defmode current
						elseif (Options.defMode==0) then
							if (Options.defFormat==0) then
								fDef:SetText(UnitMana(unit))
							elseif (Options.defFormat==1) then		
								fDef:SetText(string.format("%.1f", (cur/1000)))
							end
						end
					elseif (UnitPowerType(unit)==1)
						or (UnitPowerType(unit)==2)
						or (UnitPowerType(unit)==3) then
							fDef:Show()
							fDef:SetText(cur)
					end
				end
			end
			this.TimeSinceLastUpdate=0
		end
	else
		--disable frame
		fBG:SetAlpha(0) 
		fBG:EnableMouse(false)
		MP_Party1_Button:EnableMouse(false)
	end
end
---------------------------------------------------------
function MP_Party2(arg1)
	unit = "party2"
	tBar = MP_PARTY2_BAR_TEXTURE
	tBG  = MP_PARTY2_BG_TEXTURE1
	fBar = MP_PARTY2_BAR
	fBG	 = MP_PARTY2_FRAME
	fMax = MP_PARTY2_MAX
	fCur = MP_PARTY2_CURRENT
	fPer = MP_PARTY2_PERCENT
	fDef = MP_PARTY2_DEFICIT
	
	if (Options.showParty==1) then
		--enable frame
		fBG:SetAlpha(Colors.mp100.a)
		fBG:EnableMouse(true)
		MP_Party2_Button:EnableMouse(true)
		this.TimeSinceLastUpdate=this.TimeSinceLastUpdate + arg1
		if (this.TimeSinceLastUpdate > Options.update) then	
			if (UnitExists(unit)) then
		--Color
			ManaColor(unit,tBar,tBG,fCur,fPer,fDef)
		--Health
			local cur, max = UnitMana(unit), UnitManaMax(unit)
			local deficit = max-cur
			--mp bar
				if (cur==0) then
					fBar:SetHeight(1)
				else
					if (max>=cur) then
						fBar:SetHeight(((Options.bgHeight/4)-3)/max*cur)
					else
						fBar:SetHeight((Options.bgHeight/4)-3)
					end
				end
			--mp max text
				fMax:Hide()
			--mp current text
				fCur:Hide()
			--mp percent text
				fPer:Hide()
			--mp deficit text
				if (cur/max)>0.9
				or (cur/max)<0.1 then 
					fDef:Hide()
				else
					if (UnitPowerType(unit)==0) then
						fDef:Show()
					--defmode deficit
						if (Options.defMode==1) then
							if (Options.defFormat==0) then
								fDef:SetText("-" ..deficit)
							elseif (Options.defFormat==1) then		
								fDef:SetText(string.format("-%.1f", (deficit/1000)))
							end
					--defmode current
						elseif (Options.defMode==0) then
							if (Options.defFormat==0) then
								fDef:SetText(UnitMana(unit))
							elseif (Options.defFormat==1) then		
								fDef:SetText(string.format("%.1f", (cur/1000)))
							end
						end
					elseif (UnitPowerType(unit)==1)
						or (UnitPowerType(unit)==2)
						or (UnitPowerType(unit)==3) then
							fDef:Show()
							fDef:SetText(cur)
					end
				end
			end
			this.TimeSinceLastUpdate=0
		end
	else
		--disable frame
		fBG:SetAlpha(0) 
		fBG:EnableMouse(false)
		MP_Party2_Button:EnableMouse(false)
	end
end
---------------------------------------------------------
function MP_Party3(arg1)
	unit = "party3"
	tBar = MP_PARTY3_BAR_TEXTURE
	tBG  = MP_PARTY3_BG_TEXTURE1
	fBar = MP_PARTY3_BAR
	fBG	 = MP_PARTY3_FRAME
	fMax = MP_PARTY3_MAX
	fCur = MP_PARTY3_CURRENT
	fPer = MP_PARTY3_PERCENT
	fDef = MP_PARTY3_DEFICIT
	
	if (Options.showParty==1) then
		--enable frame
		fBG:SetAlpha(Colors.mp100.a)
		fBG:EnableMouse(true)
		MP_Party3_Button:EnableMouse(true)
		this.TimeSinceLastUpdate=this.TimeSinceLastUpdate + arg1
		if (this.TimeSinceLastUpdate > Options.update) then	
			if (UnitExists(unit)) then
		--Color
			ManaColor(unit,tBar,tBG,fCur,fPer,fDef)
		--Health
			local cur, max = UnitMana(unit), UnitManaMax(unit)
			local deficit = max-cur
			--mp bar
				if (cur==0) then
					fBar:SetHeight(1)
				else
					if (max>=cur) then
						fBar:SetHeight(((Options.bgHeight/4)-3)/max*cur)
					else
						fBar:SetHeight((Options.bgHeight/4)-3)
					end
				end
			--mp max text
				fMax:Hide()
			--mp current text
				fCur:Hide()
			--mp percent text
				fPer:Hide()
			--mp deficit text
				if (cur/max)>0.9
				or (cur/max)<0.1 then 
					fDef:Hide()
				else
					if (UnitPowerType(unit)==0) then
						fDef:Show()
					--defmode deficit
						if (Options.defMode==1) then
							if (Options.defFormat==0) then
								fDef:SetText("-" ..deficit)
							elseif (Options.defFormat==1) then		
								fDef:SetText(string.format("-%.1f", (deficit/1000)))
							end
					--defmode current
						elseif (Options.defMode==0) then
							if (Options.defFormat==0) then
								fDef:SetText(UnitMana(unit))
							elseif (Options.defFormat==1) then		
								fDef:SetText(string.format("%.1f", (cur/1000)))
							end
						end
					elseif (UnitPowerType(unit)==1)
						or (UnitPowerType(unit)==2)
						or (UnitPowerType(unit)==3) then
							fDef:Show()
							fDef:SetText(cur)
					end
				end
			end
			this.TimeSinceLastUpdate=0
		end
	else
		--disable frame
		fBG:SetAlpha(0) 
		fBG:EnableMouse(false)
		MP_Party3_Button:EnableMouse(false)
	end
end
---------------------------------------------------------
function MP_Party4(arg1)
	unit = "party4"
	tBar = MP_PARTY4_BAR_TEXTURE
	tBG  = MP_PARTY4_BG_TEXTURE1
	fBar = MP_PARTY4_BAR
	fBG	 = MP_PARTY4_FRAME
	fMax = MP_PARTY4_MAX
	fCur = MP_PARTY4_CURRENT
	fPer = MP_PARTY4_PERCENT
	fDef = MP_PARTY4_DEFICIT
	
	if (Options.showParty==1) then
		--enable frame
		fBG:SetAlpha(Colors.mp100.a)
		fBG:EnableMouse(true)
		MP_Party4_Button:EnableMouse(true)
		this.TimeSinceLastUpdate=this.TimeSinceLastUpdate + arg1
		if (this.TimeSinceLastUpdate > Options.update) then	
			if (UnitExists(unit)) then
		--Color
			ManaColor(unit,tBar,tBG,fCur,fPer,fDef)
		--Health
			local cur, max = UnitMana(unit), UnitManaMax(unit)
			local deficit = max-cur
			--mp bar
				if (cur==0) then
					fBar:SetHeight(1)
				else
					if (max>=cur) then
						fBar:SetHeight(((Options.bgHeight/4)-3)/max*cur)
					else
						fBar:SetHeight((Options.bgHeight/4)-3)
					end
				end
			--mp max text
				fMax:Hide()
			--mp current text
				fCur:Hide()
			--mp percent text
				fPer:Hide()
			--mp deficit text
				if (cur/max)>0.9
				or (cur/max)<0.1 then 
					fDef:Hide()
				else
					if (UnitPowerType(unit)==0) then
						fDef:Show()
					--defmode deficit
						if (Options.defMode==1) then
							if (Options.defFormat==0) then
								fDef:SetText("-" ..deficit)
							elseif (Options.defFormat==1) then		
								fDef:SetText(string.format("-%.1f", (deficit/1000)))
							end
					--defmode current
						elseif (Options.defMode==0) then
							if (Options.defFormat==0) then
								fDef:SetText(UnitMana(unit))
							elseif (Options.defFormat==1) then		
								fDef:SetText(string.format("%.1f", (cur/1000)))
							end
						end
					elseif (UnitPowerType(unit)==1)
						or (UnitPowerType(unit)==2)
						or (UnitPowerType(unit)==3) then
							fDef:Show()
							fDef:SetText(cur)
					end
				end
			end
			this.TimeSinceLastUpdate=0
		end
	else
		--disable frame
		fBG:SetAlpha(0) 
		fBG:EnableMouse(false)
		MP_Party4_Button:EnableMouse(false)
	end
end
---------------------------------------------------------
function MP_Pet(arg1)
	unit = "pet"
	tBar = MP_PET_BAR_TEXTURE
	tBG  = MP_PET_BG_TEXTURE1
	fBar = MP_PET_BAR
	fBG	 = MP_PET_FRAME	
	fMax = MP_PET_MAX
	fCur = MP_PET_CURRENT
	fPer = MP_PET_PERCENT
	fDef = MP_PET_DEFICIT
	
	if (Options.showPet==1) then
		--enable frame
		fBG:SetAlpha(Colors.mp100.a)
		fBG:EnableMouse(true)
		MP_Pet_Button:EnableMouse(true)
		this.TimeSinceLastUpdate=this.TimeSinceLastUpdate + arg1
		if (this.TimeSinceLastUpdate > Options.update) then	
			if (UnitExists(unit)) then	
			--Color
			ManaColor(unit,tBar,tBG,fCur,fPer,fDef)
			--Health
			local cur, max = UnitMana(unit), UnitManaMax(unit)
			local deficit = max-cur	
			--mp bar
				if (cur==0) then
					fBar:SetHeight(1)
				else
					if (max>=cur) then
						fBar:SetHeight((Options.bgHeight/2)/max*cur)
					else
						fBar:SetHeight(Options.bgHeight/2)
					end
				end
			--mp max text
				fMax:SetText(UnitManaMax(unit))
				if (UnitPowerType(unit)==0) then
					fMax:SetTextColor(0, 0, 1, 1)
				elseif (UnitPowerType(unit)==1) then
					fMax:SetTextColor(1, 0, 0, 1)
				elseif (UnitPowerType(unit)==2) then
					fMax:SetTextColor(1, 1, 0, 1)
				elseif (UnitPowerType(unit)==3) then
					fMax:SetTextColor(1, 1, 0, 1)
				end
			--mp current text
				fCur:SetText(cur)
			--mp percent text
				fPer:SetText(string.format("%.0f", (100/max*cur)) .."%")
			--mp deficit text
				if (cur/max)>0.9
				or (cur/max)<0.1 then 
					fDef:Hide()
				else
					if (UnitPowerType(unit)==0) then
						fDef:Show()
						if (Options.defFormat==0) then
							fDef:SetText("-" ..deficit)
						elseif (Options.defFormat==1) then		
							fDef:SetText(string.format("-%.1f", (deficit/1000)))
						end
					elseif (UnitPowerType(unit)==1)
						or (UnitPowerType(unit)==2)
						or (UnitPowerType(unit)==3) then
							fDef:Show()
							fDef:SetText(cur)
					end
				end
			end
			this.TimeSinceLastUpdate=0
		end
	else
		--disable frame
		fBG:SetAlpha(0) 
		fBG:EnableMouse(false)
		MP_Pet_Button:EnableMouse(false)
	end
end
---------------------------------------------------------
function MP_TargetTarget(arg1)
	unit = "targettarget"
	tBar = MP_TARGETTARGET_BAR_TEXTURE
	tBG  = MP_TARGETTARGET_BG_TEXTURE1
	fBar = MP_TARGETTARGET_BAR
	fBG	 = MP_TARGETTARGET_FRAME	
	fMax = MP_TARGETTARGET_MAX
	fCur = MP_TARGETTARGET_CURRENT
	fPer = MP_TARGETTARGET_PERCENT
	fDef = MP_TARGETTARGET_DEFICIT
	
	if (Options.showTT==1) then
		--enable frame
		fBG:SetAlpha(Colors.mp100.a)
		fBG:EnableMouse(true)
		MP_TargetTarget_Button:EnableMouse(true)
		this.TimeSinceLastUpdate=this.TimeSinceLastUpdate + arg1
		if (this.TimeSinceLastUpdate > Options.update) then	
			if (UnitExists(unit)) then
			--Color
			ManaColor(unit,tBar,tBG,fCur,fPer,fDef)
			--Health
			local cur, max = UnitMana(unit), UnitManaMax(unit)
			local deficit = max-cur	
			--mp bar
				if (cur==0) then
					fBar:SetHeight(1)
				else
					if (max>=cur) then
						fBar:SetHeight((Options.bgHeight/2)/max*cur)
					else
						fBar:SetHeight(Options.bgHeight/2)
					end
				end
			--mp max text
				fMax:SetText(UnitManaMax(unit))
				if (UnitPowerType(unit)==0) then
					fMax:SetTextColor(0, 0, 1, 1)
				elseif (UnitPowerType(unit)==1) then
					fMax:SetTextColor(1, 0, 0, 1)
				elseif (UnitPowerType(unit)==2) then
					fMax:SetTextColor(1, 1, 0, 1)
				elseif (UnitPowerType(unit)==3) then
					fMax:SetTextColor(1, 1, 0, 1)
				end
			--mp current text
				fCur:SetText(cur)
			--mp percent text
				fPer:SetText(string.format("%.0f", (100/max*cur)) .."%")
			--mp deficit text
				if (cur/max)>0.9
				or (cur/max)<0.1 then 
					fDef:Hide()
				else
					if (UnitPowerType(unit)==0) then
						fDef:Show()
						if (Options.defFormat==0) then
							fDef:SetText("-" ..deficit)
						elseif (Options.defFormat==1) then		
							fDef:SetText(string.format("-%.1f", (deficit/1000)))
						end
					elseif (UnitPowerType(unit)==1)
						or (UnitPowerType(unit)==2)
						or (UnitPowerType(unit)==3) then
							fDef:Show()
							fDef:SetText(cur)
					end
				end
			end
			this.TimeSinceLastUpdate=0
		end
	else
		--disable frame
		fBG:SetAlpha(0) 
		fBG:EnableMouse(false)
		MP_TargetTarget_Button:EnableMouse(false)
	end
end
------------------------------------------------------------------------------------------------------------------
function HealthColor(unit,tBar,tBG,fCur,fPer,fDef)
	local deficit = (1-(UnitHealth(unit)/UnitHealthMax(unit)))
	-- grey frame for those conditions
	if (UnitIsTapped(unit)) and (not UnitIsTappedByPlayer(unit))
	or (UnitIsTrivial(unit))
	or (UnitIsDeadOrGhost(unit))
	or (not UnitIsConnected(unit)) then
		local r,g,b,a = 0.5, 0.5, 0.5, Colors.hp100.a
		ColorFrames(r,g,b,a)
		--stop flash
		UIFrameFlashRemoveFrame(tBar)
		UIFrameFlashRemoveFrame(tBG)
	else
		--100
		if (deficit == 0) then 
			local r,g,b,a = Colors.hp100.r, Colors.hp100.g, Colors.hp100.b, Colors.hp100.a
			ColorFrames(r,g,b,a)
			--stop flash
			UIFrameFlashRemoveFrame(tBar)
			UIFrameFlashRemoveFrame(tBG)
		--  > 0 < 0.5
		elseif (deficit > 0) and (deficit < 0.5) then 
			local r,g,b,a = deficit*2, Colors.hp100.g, Colors.hp100.b, Colors.hp100.a
			ColorFrames(r,g,b,a)
			--stop flash
			UIFrameFlashRemoveFrame(tBar)
			UIFrameFlashRemoveFrame(tBG)
		-- >0.5 < 0.8
		elseif (deficit > 0.5) and (deficit < 0.8) then
			local r,g,b,a = Colors.hp50.r, (1-deficit)*2, Colors.hp50.b, Colors.hp50.a
			ColorFrames(r,g,b,a)
			--stop flash
			UIFrameFlashRemoveFrame(tBar)
			UIFrameFlashRemoveFrame(tBG)
		-- 20-
		elseif (deficit == 0.8) or (deficit > 0.8) then 
			local r,g,b = Colors.hp20.r, Colors.hp20.g, Colors.hp20.b
			ColorFrames(r,g,b)
			--startflashing
			if (Options.flash.Bar==1) then
				UIFrameFlash(tBar, Options.flash.In, Options.flash.Out, Options.flash.Duration, true, Options.flash.InHold, Options.flash.OutHold)
			end
			if (Options.flash.BG==1) then
				UIFrameFlash(tBG, Options.flash.In, Options.flash.Out, Options.flash.Duration, true, Options.flash.InHold, Options.flash.OutHold)
			end	
		end
	end
end
---------------------------------------------------------
function ManaColor(unit,tBar,tBG,fCur,fPer,fDef)
	local deficit = (1-(UnitMana(unit)/UnitManaMax(unit)))
	--powertype mana
	if (UnitPowerType(unit)==0) then 
		-- grey frame for those conditions
		if (UnitIsTapped(unit)) and (not UnitIsTappedByPlayer(unit))
		or (UnitIsTrivial(unit))
		or (UnitIsDeadOrGhost(unit))
		or (not UnitIsConnected(unit)) then
			local r,g,b,a = 0.5, 0.5, 0.5, Colors.hp100.a
			ColorFrames(r,g,b,a)
			--stop flash
			UIFrameFlashRemoveFrame(tBar)
			UIFrameFlashRemoveFrame(tBG)
		else
			--100
			if (deficit == 0) then 
				local r,g,b,a = Colors.mp100.r, Colors.mp100.g, Colors.mp100.b, Colors.mp100.a
				ColorFrames(r,g,b,a)
				--stop flash
				UIFrameFlashRemoveFrame(tBar)
				UIFrameFlashRemoveFrame(tBG)
			--  > 0 < 0.5
			elseif (deficit > 0) and (deficit < 0.5) then 
				local r,g,b,a = deficit*2, deficit*2, Colors.mp100.b, Colors.mp100.a
				ColorFrames(r,g,b,a)
				--stop flash
				UIFrameFlashRemoveFrame(tBar)
				UIFrameFlashRemoveFrame(tBG)
			-- >0.5 < 0.8
			elseif (deficit > 0.5) and (deficit < 0.8) then
				local r,g,b,a = Colors.mp50.r, (1-deficit)*2, (1-deficit)*2, Colors.mp50.a
				ColorFrames(r,g,b,a)
				--stop flash
				UIFrameFlashRemoveFrame(tBar)
				UIFrameFlashRemoveFrame(tBG)
			-- 20-
			elseif (deficit == 0.8) or (deficit > 0.8) then
				local r,g,b = Colors.mp20.r, Colors.mp20.g, Colors.mp20.b
				ColorFrames(r,g,b)
			--startflashing
				if (Options.flash.Bar==1) then
					UIFrameFlash(tBar, Options.flash.In, Options.flash.Out, Options.flash.Duration, true, Options.flash.InHold, Options.flash.OutHold)
				end
				if (Options.flash.BG==1) then
					UIFrameFlash(tBG, Options.flash.In, Options.flash.Out, Options.flash.Duration, true, Options.flash.InHold, Options.flash.OutHold)
				end
			end
		end
	--powertype rage
	elseif (UnitPowerType(unit)==1) then 
		-- grey frame for those conditions
		if (UnitIsTapped(unit)) and (not UnitIsTappedByPlayer(unit))
		or (UnitIsTrivial(unit))
		or (UnitIsDeadOrGhost(unit))
		or (not UnitIsConnected(unit)) then
			local r,g,b,a = 0.5, 0.5, 0.5, Colors.hp100.a
			ColorFrames(r,g,b,a)
			--stop flash
			UIFrameFlashRemoveFrame(tBar)
			UIFrameFlashRemoveFrame(tBG)
		else
			local r,g,b,a = 1, 0, 0, Colors.mp100.a
			ColorFrames(r,g,b,a)
			--stop flash
			UIFrameFlashRemoveFrame(tBar)
			UIFrameFlashRemoveFrame(tBG)
		end
	--powertype focus/energy
	elseif (UnitPowerType(unit)==2) or (UnitPowerType(unit)==3) then -- grey frame for those conditions
		if (UnitIsTapped(unit)) and (not UnitIsTappedByPlayer(unit))
		or (UnitIsTrivial(unit))
		or (UnitIsDeadOrGhost(unit))
		or (not UnitIsConnected(unit)) then
			local r,g,b,a = 0.5, 0.5, 0.5, Colors.hp100.a
			ColorFrames(r,g,b,a)
			--stop flash
			UIFrameFlashRemoveFrame(tBar)
			UIFrameFlashRemoveFrame(tBG)
		else
			local r,g,b,a = 1, 1, 0, Colors.mp100.a
			ColorFrames(r,g,b,a)
			--stop flash
			UIFrameFlashRemoveFrame(tBar)
			UIFrameFlashRemoveFrame(tBG)
		end
	end
end
---------------------------------------------------------
function ClassColor(unit,fNam)
	local playerClass, englishClass = UnitClass(unit)
	if (englishClass=="DRUID") then
		local r,g,b,a = 1.0, 0.49, 0.04, Colors.hp100.a
		fNam:SetTextColor(r,g,b,a)
	elseif (englishClass=="HUNTER") then
		local r,g,b,a = 0.67, 0.83, 0.45, Colors.hp100.a 
		fNam:SetTextColor(r,g,b,a)
	elseif (englishClass=="MAGE") then
		local r,g,b,a = 0.41, 0.8, 0.94, Colors.hp100.a 
		fNam:SetTextColor(r,g,b,a)
	elseif (englishClass=="PALADIN") then
		local r,g,b,a = 0.96, 0.55, 0.73, Colors.hp100.a 
		fNam:SetTextColor(r,g,b,a)
	elseif (englishClass=="PRIEST") then
		local r,g,b,a = 1.0, 1.0, 1.0, Colors.hp100.a
		fNam:SetTextColor(r,g,b,a)
	elseif (englishClass=="ROGUE") then
		local r,g,b,a = 1.0, 0.96, 0.41, Colors.hp100.a 
		fNam:SetTextColor(r,g,b,a)
	elseif (englishClass=="SHAMAN") then
		local r,g,b,a = 0, 0.86, 0.73, Colors.hp100.a 
		fNam:SetTextColor(r,g,b,a)
	elseif (englishClass=="WARLOCK") then
		local r,g,b,a = 0.58, 0.51, 0.79, Colors.hp100.a 
		fNam:SetTextColor(r,g,b,a)
	elseif (englishClass=="WARRIOR") then
		local r,g,b,a = 0.78, 0.61, 0.43, Colors.hp100.a 
		fNam:SetTextColor(r,g,b,a)
	end
end
---------------------------------------------------------
function ColorFrames(r,g,b,a)
	tBar:SetVertexColor(r,g,b,a)
	tBG:SetVertexColor(r,g,b,a)
	fCur:SetTextColor(r,g,b,a)
	fPer:SetTextColor(r,g,b,a)
	fDef:SetTextColor(r,g,b,a)
end